#include "Skybox.h"
#include <stdio.h>
#include <stdlib.h>
#include <GL/glut.h>
#include "inc/GL/glaux.h"
#define TEX_SIZE 3
#define GL_CLAMP_TO_EDGE 0x812F
const char *texFiles[6]={
	"space/front.bmp",
	"space/back.bmp",
	"space/left.bmp",
	"space/right.bmp",
	"space/up.bmp",
	"space/down.bmp"};

Skybox::Skybox(void){
	for(int i=0; i<6; i++)
		textures[i]=_loadTexture(texFiles[i]);
}
Skybox::~Skybox(void){}
void Skybox::draw(){
	glEnable(GL_TEXTURE_2D);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();

	// skybox    ʵ depth_test 
	//glDepthMask(GL_FALSE);
	glDisable(GL_DEPTH_TEST);
	// Skybox ٸ    ȵǹǷ DECAL
	glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL);
	glColor3f(0,0,0);

	//front
	glBindTexture(GL_TEXTURE_2D,textures[0]);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-TEX_SIZE,-TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(1.0, 0.0); glVertex3f(TEX_SIZE,-TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(1.0, 1.0); glVertex3f(TEX_SIZE,TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(0.0, 1.0); glVertex3f(-TEX_SIZE,TEX_SIZE,-TEX_SIZE);
	glEnd();

	//back
	glBindTexture(GL_TEXTURE_2D, textures[1]);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(TEX_SIZE,-TEX_SIZE,TEX_SIZE);
		glTexCoord2f(1.0, 0.0); glVertex3f(-TEX_SIZE,-TEX_SIZE,TEX_SIZE);
		glTexCoord2f(1.0, 1.0); glVertex3f(-TEX_SIZE,TEX_SIZE,TEX_SIZE);
		glTexCoord2f(0.0, 1.0); glVertex3f(TEX_SIZE,TEX_SIZE,TEX_SIZE);
	glEnd();

	//left
	glBindTexture(GL_TEXTURE_2D, textures[2]);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(TEX_SIZE,-TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(1.0, 0.0); glVertex3f(TEX_SIZE,-TEX_SIZE,TEX_SIZE);
		glTexCoord2f(1.0, 1.0); glVertex3f(TEX_SIZE,TEX_SIZE,TEX_SIZE);
		glTexCoord2f(0.0, 1.0); glVertex3f(TEX_SIZE,TEX_SIZE,-TEX_SIZE);
	glEnd();

	//right
	glBindTexture(GL_TEXTURE_2D, textures[3]);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-TEX_SIZE,-TEX_SIZE,TEX_SIZE);
		glTexCoord2f(1.0, 0.0); glVertex3f(-TEX_SIZE,-TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(1.0, 1.0); glVertex3f(-TEX_SIZE,TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(0.0, 1.0); glVertex3f(-TEX_SIZE,TEX_SIZE,TEX_SIZE);
	glEnd();

	//up
	glBindTexture(GL_TEXTURE_2D, textures[4]);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-TEX_SIZE,TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(1.0, 0.0); glVertex3f(TEX_SIZE,TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(1.0, 1.0); glVertex3f(TEX_SIZE,TEX_SIZE,TEX_SIZE);
		glTexCoord2f(0.0, 1.0); glVertex3f(-TEX_SIZE,TEX_SIZE,TEX_SIZE);
	glEnd();

	//down
	glBindTexture(GL_TEXTURE_2D, textures[5]);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 0.0); glVertex3f(-TEX_SIZE,-TEX_SIZE,TEX_SIZE);
		glTexCoord2f(1.0, 0.0); glVertex3f(TEX_SIZE,-TEX_SIZE,TEX_SIZE);
		glTexCoord2f(1.0, 1.0); glVertex3f(TEX_SIZE,-TEX_SIZE,-TEX_SIZE);
		glTexCoord2f(0.0, 1.0); glVertex3f(-TEX_SIZE,-TEX_SIZE,-TEX_SIZE);
	glEnd();

	//glDepthMask(GL_TRUE);
	glEnable(GL_DEPTH_TEST);
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
}

Skybox::uint Skybox::_loadTexture(pcStr filename){
	// aux  malloc̹Ƿ free ʼ
	AUX_RGBImageRec* img=auxDIBImageLoadA(filename);
	// ؽ 
	GLuint texId;
	glGenTextures(1,&texId);
	glBindTexture(GL_TEXTURE_2D, texId);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, img->sizeX, img->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, img->data);
	// ؽ Ȯ  
	glTexParameteri(GL_TEXTURE_2D ,GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D ,GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	// CLAMP_TO_EDGE Ķʹ EDGE  踦 Ȯ
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	// ޸ Ҵ 
	free(img->data);
	free(img);
	return texId;
}